## fw4spl 0.9.2

=== CMakeLists.txt ===

cmake_minimum_required (VERSION 2.8.11)

project (fw4spl)

enable_testing()

include(CheckVariableExists)
include(CMakeParseArguments)

option(CLASSIC_INSTALL ON)
set(CLASSIC_INSTALL OFF)
set( EXTERNAL_LIBRARIES ${CMAKE_CURRENT_SOURCE_DIR}/CMake/Modules/ )

if(CLASSIC_INSTALL)
    set( LIBRARY_OUTPUT_DIR "lib" )
    set( SHARE_OUTPUT_DIR "share" )
    add_definitions( -DLIBSFW4SPL=\"\" )
    add_definitions( -DBUNDLEPATH=\"\" )
    add_definitions( -DSHAREPATH=\"\" )
else()
    set( CMAKE_BUILD_TYPE Release)
    set( CMAKE_INSTALL_PREFIX /usr )
    set( PROJECTS_TO_BUILD VRRender )
    set( PROJECTS_TO_INSTALL VRRender )
    set( SHARE_OUTPUT_DIR "share/fw4spl" )
    set( LIBRARY_OUTPUT_DIR "lib/fw4spl" )
    add_definitions( -DSPECIALINSTALL )
    add_definitions( -DLIBSFW4SPL=\"/usr/lib/fw4spl/\" )
    add_definitions( -DBUNDLEPATH=\"/usr/share/fw4spl/Bundles/\" )
    add_definitions( -DSHAREPATH=\"/usr/share/fw4spl/\" )
endif()

set( RUNTIME_OUTPUT_DIR "bin" )

set(BUILD_SHARED_LIBS ON)

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")  #racy backward compatibility

set(CREATE_SUBPROJECTS OFF CACHE BOOL "Create a project for each subproject")

set(BUILD_TESTS ON CACHE BOOL "Configures projects associated tests (<project>Test projects)")

set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake/)

if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    #http://stackoverflow.com/questions/6802903/c-ifdef-mac-os-x-question
    add_definitions(-D__MACOSX__) #racy backward compatibility
    set(LIBRARY_OUTPUT_DIR Libraries)
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIR})

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})


set(SPYLOG_LEVEL "error" CACHE STRING "Log level")
set(SPYLOG_LEVEL_VALUES "fatal;error;warning;info;debug;trace" CACHE INTERNAL
    "List of possible values for log level")
set(SPYLOG_LEVEL_MAP_fatal 1)
set(SPYLOG_LEVEL_MAP_error 2)
set(SPYLOG_LEVEL_MAP_warning 3)
set(SPYLOG_LEVEL_MAP_info 4)
set(SPYLOG_LEVEL_MAP_debug 5)
set(SPYLOG_LEVEL_MAP_trace 6)
set_property(CACHE SPYLOG_LEVEL PROPERTY STRINGS ${SPYLOG_LEVEL_VALUES} )

# Until c++11 beeing globaly enabled ...
macro(fwEnableCpp11)
    if(NOT WIN32)
        add_definitions("--std=c++11")
        if(APPLE)
            add_definitions("--stdlib=libc++")
        endif(APPLE)
    endif()
endmacro()

macro(initProject PRJNAME )
    if(CREATE_SUBPROJECTS)
        project( ${PRJNAME} )
    endif()
    set(FWPROJECT_NAME ${PRJNAME})
    set(PRJ_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

    set(${FWPROJECT_NAME}_HEADERS)
    set(${FWPROJECT_NAME}_SOURCES)

    set(SUBDIRS ${ARGN})
    list(LENGTH SUBDIRS NB_SUBDIRS)
    if(NB_SUBDIRS EQUAL 0)
        list(APPEND SUBDIRS ${PRJ_SOURCE_DIR})
    endif()

    set(${FWPROJECT_NAME}_INCLUDE_DIR)

    foreach(SUBDIR ${SUBDIRS})
        list(APPEND ${FWPROJECT_NAME}_INCLUDE_DIR ${SUBDIR}/include)

        file(GLOB_RECURSE HEADERS ${SUBDIR}/include/*)
        file(GLOB_RECURSE SOURCES ${SUBDIR}/src/*)

        list(APPEND ${FWPROJECT_NAME}_HEADERS ${HEADERS})
        list(APPEND ${FWPROJECT_NAME}_SOURCES ${SOURCES})
    endforeach(SUBDIR)

    set (${FWPROJECT_NAME}_INCLUDE_DIR ${${FWPROJECT_NAME}_INCLUDE_DIR} PARENT_SCOPE) 

    set (${FWPROJECT_NAME}_HEADERS ${${FWPROJECT_NAME}_HEADERS} PARENT_SCOPE) 
    set (${FWPROJECT_NAME}_SOURCES ${${FWPROJECT_NAME}_SOURCES} PARENT_SCOPE) 
endmacro(initProject)


macro(setVersion FWPROJECT_NAME PROJECT_VERSION)
    set(${FWPROJECT_NAME}_VERSION ${PROJECT_VERSION} )
    set(${FWPROJECT_NAME}_VERSION ${PROJECT_VERSION} PARENT_SCOPE)
    string(REPLACE "." "-" DASH_VERSION "${PROJECT_VERSION}")
    set(${FWPROJECT_NAME}_DASH_VERSION ${DASH_VERSION} )
    set(${FWPROJECT_NAME}_DASH_VERSION ${DASH_VERSION} PARENT_SCOPE)
endmacro()

macro(configureProject FWPROJECT_NAME PROJECT_VERSION)
    string(TOUPPER ${FWPROJECT_NAME} PROJECT_NAME_UPCASE)

    setVersion(${FWPROJECT_NAME} ${PROJECT_VERSION})
    string(REGEX MATCH "^[^.]+" API_VERSION ${PROJECT_VERSION})
    set_target_properties(${FWPROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${API_VERSION})
    set_target_properties(${FWPROJECT_NAME} PROPERTIES DEFINE_SYMBOL ${PROJECT_NAME_UPCASE}_EXPORTS)

    add_definitions(-D${PROJECT_NAME_UPCASE}_VER="${DASH_VERSION}")

    get_target_property(TARGET_TYPE ${FWPROJECT_NAME} TYPE)

    if (NOT ${TARGET_TYPE} MATCHES "EXECUTABLE")
        get_target_property(${FWPROJECT_NAME}_LIBRARY ${FWPROJECT_NAME} LOCATION)
        set(${FWPROJECT_NAME}_LIBRARY ${${FWPROJECT_NAME}_LIBRARY} PARENT_SCOPE)
    endif()

    target_include_directories(${FWPROJECT_NAME} PUBLIC ${${FWPROJECT_NAME}_INCLUDE_DIR})

    set(SPYLOG_LEVEL_${FWPROJECT_NAME} "${SPYLOG_LEVEL}" CACHE STRING "${FWPROJECT_NAME}'s Log level" )
    set_property(CACHE SPYLOG_LEVEL_${FWPROJECT_NAME} PROPERTY STRINGS ${SPYLOG_LEVEL_VALUES} )
    mark_as_advanced(SPYLOG_LEVEL_${FWPROJECT_NAME})

    if( SPYLOG_LEVEL_MAP_${SPYLOG_LEVEL_${FWPROJECT_NAME}} )
        add_definitions(-DSPYLOG_LEVEL=${SPYLOG_LEVEL_MAP_${SPYLOG_LEVEL_${FWPROJECT_NAME}}})
    else()
        message(SEND_ERROR "${SPYLOG_LEVEL_${FWPROJECT_NAME}} is not a valid value for SPYLOG_LEVEL_${FWPROJECT_NAME}" )
    endif()
    unset(SPYLOG_VALID_VALUE)

endmacro(configureProject)


macro(createResourcesTarget TARGET RES_DIR TARGET_DIR)
    file(GLOB_RECURSE RESOURCES_FILES "${RES_DIR}/*")
    set(CREATED_RESOURCES_LIST)
    foreach(RESOURCE_FILE ${RESOURCES_FILES})
        file(RELATIVE_PATH REL_PATH "${RES_DIR}" "${RESOURCE_FILE}")
        if ("${TARGET_DIR}/${REL_PATH}" MATCHES "^.*\\.(txt|xml)$")
            set(COPY_COMMAND cmake
            -DIN_FILE="${RES_DIR}/${REL_PATH}" 
            -DOUT_FILE="${TARGET_DIR}/${REL_PATH}" 
            -DFWPROJECT_NAME="${FWPROJECT_NAME}"
            -DDASH_VERSION="${${FWPROJECT_NAME}_DASH_VERSION}"
            -DPROJECT_VERSION="${${FWPROJECT_NAME}_VERSION}"
            -DTARGET_TYPE="${TARGET_TYPE}"
            -P ${FWCMAKE_RESOURCE_PATH}/build/configure_file.cmake
            )
            set(COPY_DEPENDS "${FWCMAKE_RESOURCE_PATH}/build/configure_file.cmake" )
        else()
            set(COPY_COMMAND cmake -E copy "${RES_DIR}/${REL_PATH}" "${TARGET_DIR}/${REL_PATH}")
            set(COPY_DEPENDS )
        endif()

        add_custom_command(OUTPUT "${TARGET_DIR}/${REL_PATH}"
            # COMMAND cmake -E copy "${RES_DIR}/${REL_PATH}" "${TARGET_DIR}/${REL_PATH}"
            COMMAND ${COPY_COMMAND}
            DEPENDS "${RES_DIR}/${REL_PATH}" ${COPY_DEPENDS}
            ) 
        LIST (APPEND CREATED_RESOURCES_LIST "${TARGET_DIR}/${REL_PATH}")
    endforeach()

    add_custom_target("${TARGET}" ALL DEPENDS ${CREATED_RESOURCES_LIST} )

    unset(CREATED_RESOURCES_LIST)
endmacro()

macro(createResourcesInstallTarget RES_DIR CONFIGURED_FILES_DIR DESTINATION)
    file(GLOB_RECURSE RESOURCES_FILES "${RES_DIR}/*")
    foreach(RESOURCE_FILE ${RESOURCES_FILES})
        file(RELATIVE_PATH REL_PATH "${RES_DIR}" "${RESOURCE_FILE}")
        get_filename_component(RC_REL_DIR "${REL_PATH}" DIRECTORY)
        install(FILES "${CONFIGURED_FILES_DIR}/${REL_PATH}" DESTINATION "${SHARE_OUTPUT_DIR}/${DESTINATION}/${RC_REL_DIR}" )
        unset(RC_REL_DIR)
    endforeach()
endmacro()


macro(fwExec FWPROJECT_NAME PROJECT_VERSION)
    set(options CONSOLE)
    set(oneValueArgs)
    set(multiValueArgs)
    cmake_parse_arguments(FWEXEC "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )

    initProject( ${FWPROJECT_NAME} )

    set(${FWPROJECT_NAME}_TYPE "EXECUTABLE")
    set(${FWPROJECT_NAME}_TYPE ${${FWPROJECT_NAME}_TYPE} PARENT_SCOPE)
    setVersion(${FWPROJECT_NAME} ${PROJECT_VERSION})

    if(WIN32 AND NOT ${FWEXEC_CONSOLE})
        set(GUI_TYPE WIN32)
    else()
        add_definitions(-D_CONSOLE)
    endif()

    add_executable(${FWPROJECT_NAME} ${GUI_TYPE} ${${FWPROJECT_NAME}_HEADERS} ${${FWPROJECT_NAME}_SOURCES} )

    configureProject( ${FWPROJECT_NAME} ${PROJECT_VERSION} )

    if(EXISTS "${PRJ_SOURCE_DIR}/rc")
        set(${FWPROJECT_NAME}_RC_BUILD_DIR "${CMAKE_BINARY_DIR}/${SHARE_OUTPUT_DIR}/${FWPROJECT_NAME}_${DASH_VERSION}")

        createResourcesTarget( ${FWPROJECT_NAME}_rc "${PRJ_SOURCE_DIR}/rc" "${${FWPROJECT_NAME}_RC_BUILD_DIR}" )
        add_dependencies( ${FWPROJECT_NAME} ${FWPROJECT_NAME}_rc )

        if(${FWPROJECT_NAME}_INSTALL)
            createResourcesInstallTarget( "${PRJ_SOURCE_DIR}/rc" "${${FWPROJECT_NAME}_RC_BUILD_DIR}" "${FWPROJECT_NAME}_${DASH_VERSION}" )
        endif()
    endif()

    if(${FWPROJECT_NAME}_INSTALL)
        install(
            TARGETS ${FWPROJECT_NAME}
            RUNTIME DESTINATION ${RUNTIME_OUTPUT_DIR}
            OPTIONAL
            )
    endif()


endmacro(fwExec)

macro(fwCppunitTest FWPROJECT_NAME)
    set(options)
    set(oneValueArgs BUNDLE WORKING_DIRECTORY)
    set(multiValueArgs)
    cmake_parse_arguments(fwCppunitTest "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )

    initProject( ${FWPROJECT_NAME} tu )

    set(${FWPROJECT_NAME}_TYPE "TEST")
    set(${FWPROJECT_NAME}_TYPE ${${FWPROJECT_NAME}_TYPE} PARENT_SCOPE)
    setVersion(${FWPROJECT_NAME} 0.0)

    add_executable(${FWPROJECT_NAME}
        ${fwCppunitTest_UNPARSED_ARGUMENTS}
        ${${FWPROJECT_NAME}_HEADERS}
        ${${FWPROJECT_NAME}_SOURCES}
        ${FWCMAKE_RESOURCE_PATH}/cppunit/cppunit_main.cpp
        )

    if(fwCppunitTest_BUNDLE)
        add_definitions(-DBUNDLE_TEST_PROFILE=\"${SHARE_OUTPUT_DIR}/tu_exec_${fwCppunitTest_BUNDLE}_0-0/profile.xml\")
    endif()

    configureProject( ${FWPROJECT_NAME} 0.0 )

    if(EXISTS "${PRJ_SOURCE_DIR}/tu/rc")
        string(REGEX REPLACE "Test$" "" DIRNAME "${FWPROJECT_NAME}")
        set(${FWPROJECT_NAME}_RC_BUILD_DIR "${CMAKE_BINARY_DIR}/${SHARE_OUTPUT_DIR}/tu_exec_${DIRNAME}_${DASH_VERSION}")
        createResourcesTarget( ${FWPROJECT_NAME}_rc "${PRJ_SOURCE_DIR}/tu/rc" "${${FWPROJECT_NAME}_RC_BUILD_DIR}" )
        add_dependencies( ${FWPROJECT_NAME} ${FWPROJECT_NAME}_rc )

        if(${FWPROJECT_NAME}_INSTALL)
            createResourcesInstallTarget( "${PRJ_SOURCE_DIR}/tu/rc"
                "${${FWPROJECT_NAME}_RC_BUILD_DIR}" 
                "unittest/tu_exec_${DIRNAME}_${DASH_VERSION}" )
        endif()
    endif()

    if(fwCppunitTest_WORKING_DIRECTORY)
        set(fwCppunitTest_WORKING_DIRECTORY WORKING_DIRECTORY ${fwCppunitTest_WORKING_DIRECTORY})
    endif()

    get_target_property(${FWPROJECT_NAME}_EXECUTABLE ${FWPROJECT_NAME} LOCATION)
    add_test( NAME ${FWPROJECT_NAME} ${fwCppunitTest_WORKING_DIRECTORY} COMMAND ${${FWPROJECT_NAME}_EXECUTABLE}  )

endmacro(fwCppunitTest)

macro(fwLib FWPROJECT_NAME PROJECT_VERSION)
    initProject( ${FWPROJECT_NAME} )

    set(${FWPROJECT_NAME}_TYPE "LIBRARY")
    set(${FWPROJECT_NAME}_TYPE ${${FWPROJECT_NAME}_TYPE} PARENT_SCOPE)
    setVersion(${FWPROJECT_NAME} ${PROJECT_VERSION})

    add_library(${FWPROJECT_NAME} ${ARGN} ${${FWPROJECT_NAME}_HEADERS} ${${FWPROJECT_NAME}_SOURCES} )

    configureProject( ${FWPROJECT_NAME} ${PROJECT_VERSION} )

    if(EXISTS "${PRJ_SOURCE_DIR}/rc")
        set(${FWPROJECT_NAME}_RC_BUILD_DIR "${CMAKE_BINARY_DIR}/${SHARE_OUTPUT_DIR}/${FWPROJECT_NAME}_${DASH_VERSION}")
        createResourcesTarget( ${FWPROJECT_NAME}_rc "${PRJ_SOURCE_DIR}/rc" "${${FWPROJECT_NAME}_RC_BUILD_DIR}" )
        add_dependencies( ${FWPROJECT_NAME} ${FWPROJECT_NAME}_rc )

        if(${FWPROJECT_NAME}_INSTALL)
            createResourcesInstallTarget( "${PRJ_SOURCE_DIR}/rc" "${${FWPROJECT_NAME}_RC_BUILD_DIR}" "${FWPROJECT_NAME}_${DASH_VERSION}" )
        endif()

    endif()

    if(${FWPROJECT_NAME}_INSTALL)
        install(
            TARGETS ${FWPROJECT_NAME}
            RUNTIME DESTINATION ${RUNTIME_OUTPUT_DIR}
            LIBRARY DESTINATION ${LIBRARY_OUTPUT_DIR}
            OPTIONAL
            )
    endif()

endmacro(fwLib)


macro(fwBundle FWPROJECT_NAME PROJECT_VERSION)

=== launcher/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS filesystem program_options REQUIRED)
fwInclude(${Boost_INCLUDE_DIRS})
fwLink(${Boost_LIBRARIES})

=== Apps/TutoPython/CMakeLists.txt ===
fwLoadProperties()


if(NOT EXISTS "${EXTERNAL_LIBRARIES}/lib/site-packages/")
    message(SEND_ERROR "numpy is required for TutoPython and it is not found in : ${EXTERNAL_LIBRARIES}/lib/site-packages/ ")
else()
    file(COPY "${EXTERNAL_LIBRARIES}/lib/site-packages/" DESTINATION "${CMAKE_BINARY_DIR}/Python/")
    if(${NAME}_INSTALL)
        install(DIRECTORY "${EXTERNAL_LIBRARIES}/lib/site-packages/" DESTINATION share/${FWPROJECT_NAME}_${DASH_VERSION} COMPONENT Python)
    endif()
endif()

=== Apps/TutoTrianConverterCtrl/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS filesystem program_options REQUIRED)
fwInclude(${Boost_INCLUDE_DIRS})
fwLink(${Boost_LIBRARIES})

=== Apps/VRRender/CMakeLists.txt ===
fwLoadProperties()


if(VRRender_INSTALL)
    if(APPLE)
        set(FWPROJECT_NAME VRRender)

        set(VRRENDER_BUNDLE_ICON_FILE vrrender.icns) 
        set_source_files_properties(rc/${VRRENDER_BUNDLE_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)


        add_executable(
            VRRender.app MACOSX_BUNDLE
            ${launcher_HEADERS} ${launcher_SOURCES} 
            rc/${VRRENDER_BUNDLE_ICON_FILE}
            )


        set_target_properties( VRRender.app PROPERTIES OUTPUT_NAME ${FWPROJECT_NAME})

        add_definitions(-DDEFAULT_PROFILE=Bundles/${FWPROJECT_NAME}_${${FWPROJECT_NAME}_DASH_VERSION}/profile.xml)

        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_ICON_FILE ${VRRENDER_BUNDLE_ICON_FILE})
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_INFO_STRING "${FWPROJECT_NAME}")
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${${FWPROJECT_NAME}_VERSION}")
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "${${FWPROJECT_NAME}_VERSION}")
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "${FWPROJECT_NAME}")
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_COPYRIGHT "Copyright 2012-2013 IRCAD")
        set_target_properties( VRRender.app PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "com.ircad.vrrender")

        find_package (Boost COMPONENTS filesystem program_options REQUIRED)

        target_include_directories(VRRender.app PRIVATE ${Boost_INCLUDE_DIRS})
        target_link_libraries(VRRender.app fwCore fwRuntime ${Boost_LIBRARIES})

        set(APP_PATH "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/VRRender.app")

        configure_file("${fwGuiQt_SOURCE_DIR}/bin/qt.conf" "${APP_PATH}/Contents/Resources/qt.conf")
        INSTALL(CODE " file(WRITE \"${APP_PATH}/Contents/Resources/qt.conf\" \"\") " COMPONENT ApplicationBundle)

        install(
            TARGETS VRRender.app 
            BUNDLE DESTINATION . COMPONENT ApplicationBundle
            )

        set(APP_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/VRRender.app")

        install(DIRECTORY "${CMAKE_INSTALL_PREFIX}/share" DESTINATION "VRRender.app/Contents/" COMPONENT ApplicationBundle)
        install(DIRECTORY "${CMAKE_INSTALL_PREFIX}/Bundles" DESTINATION "VRRender.app/Contents/" COMPONENT ApplicationBundle)
        install(DIRECTORY "${CMAKE_INSTALL_PREFIX}/qtplugins/plugins" DESTINATION "VRRender.app/Contents/" COMPONENT ApplicationBundle)

        INSTALL(CODE "
        file(GLOB_RECURSE QTPLUGINS \"${APP_INSTALL_PATH}/Contents/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
        file(GLOB_RECURSE BUNDLES \"${APP_INSTALL_PATH}/Contents/Bundles/*/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
        include(BundleUtilities)
        fixup_bundle(\"${APP_INSTALL_PATH}\" \"\${BUNDLES};\${QTPLUGINS}\" \"${CMAKE_INSTALL_PREFIX}/${LIBRARY_OUTPUT_DIR}\")
        execute_process(
            COMMAND sh -c \"find . -type f -exec stat --format='%s' {} \\; |sort -rn | uniq -d | xargs -I{} -n1 find . -type f -size {}c -print0 | xargs -0 stat --format='%20s %n' | sort | uniq -w20 --all-repeated=separate |cut -c22- | paste - - - -d' ' | sed 's/^/ln -s -f /' | sh \" 
            WORKING_DIRECTORY ${APP_INSTALL_PATH}/Contents/MacOS
            )

        execute_process(
            COMMAND sh -c \"python ${CMAKE_SOURCE_DIR}/CMake/OSXTools/osx_install_name_tool.py -e MacOS/ $(find Bundles -iname '*.dylib') -f \"
            WORKING_DIRECTORY ${APP_INSTALL_PATH}/Contents
            )

        " COMPONENT ApplicationBundle)
         
    elseif(WIN32)
        
        set(FWPROJECT_NAME VRRender)
        set(VRRENDER_BUNDLE_ICON_FILE ${CMAKE_CURRENT_SOURCE_DIR}/rc/vrrender.ico) 
        set(LAUNCHER_PATH "bin/launcher.exe")
        set(PROFILE_PATH "Bundles/${FWPROJECT_NAME}_${${FWPROJECT_NAME}_DASH_VERSION}/profile.xml")
        
       #configure the wix template 
       configure_file(${FWCMAKE_RESOURCE_PATH}Wix/WIX.template.in ${PROJECT_BINARY_DIR}WIX.template [@ONLY] )
             
               
        install(CODE "
                      file(GLOB_RECURSE LIBS
                        \"\${CMAKE_INSTALL_PREFIX}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
                      include(BundleUtilities)
                      fixup_bundle(\"${CMAKE_INSTALL_PREFIX}/bin/launcher.exe\" \"\${LIBS}\" \"${EXTERNAL_LIBRARIES}/bin\")
                     " COMPONENT Runtime)
                     
        set(CPACK_PACKAGE_NAME "${FWPROJECT_NAME}")
        set(CPACK_INSTALLED_DIRECTORIES "${CMAKE_INSTALL_PREFIX};.") #look inside install dir for packaging
        set(CPACK_PACKAGE_VENDOR "IRCAD")
        set(CPACK_PACKAGE_ICON ${VRRENDER_BUNDLE_ICON_FILE})
        set(CPACK_PACKAGE_VERSION "${VERSION}")
                 
        if(CPACK_BINARY_WIX)
       
            set(CPACK_WIX_TEMPLATE "${PROJECT_BINARY_DIR}WIX.template")
            set(CPACK_WIX_PROGRAM_MENU_FOLDER "IRCAD" )
            set(CPACK_WIX_PRODUCT_ICON ${VRRENDER_BUNDLE_ICON_FILE})
            set(CPACK_RESOURCE_FILE_LICENSE ${FWCMAKE_RESOURCE_PATH}Wix/LICENSE.rtf)
            
        endif(CPACK_BINARY_WIX)
        
        include(CPack)

    endif()
endif()

=== Bundles/media/CMakeLists.txt ===
fwBundle(media 0.1)

=== SrcLib/ARLcore/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwCore
    fwTools
)


find_package( Boost REQUIRED )

if(CLASSIC_INSTALL)
    find_library( ANN_LIBRARY ANN )
else()
    find_library( ANN_LIBRARY ann )
endif()
find_path( ANN_INCLUDES  ANN/ANN.h)

find_library(VGL_ALGO_LIBRARY   vgl_algo )
find_library(VNL_ALGO_LIBRARY   vnl_algo )
find_library(VNL_LIBRARY        vnl )
find_library(VGL_LIBRARY        vgl )
find_library(VCL_LIBRARY        vcl )
find_library(V3P_NETLIB_LIBRARY v3p_netlib )
find_library(NETLIB_LIBRARY     netlib )

find_path( VNL_INCLUDE_PATH  vxl/core/vnl/vnl_alloc.h)

fwForwardInclude(
    ${Boost_INCLUDE_DIR}
    ${ANN_INCLUDES}
    ${VNL_INCLUDE_PATH}
    ${VNL_INCLUDE_PATH}/vxl
    ${VNL_INCLUDE_PATH}/vxl/core
    ${VNL_INCLUDE_PATH}/vxl/vcl
    )

#add linked libraries
fwLink(
    ${ANN_LIBRARY}
    ${VGL_ALGO_LIBRARY}
    ${VNL_ALGO_LIBRARY}
    ${VNL_LIBRARY}
    ${VGL_LIBRARY}
    ${VCL_LIBRARY}
    ${V3P_NETLIB_LIBRARY}
    ${NETLIB_LIBRARY}
    )

=== Bundles/LeafCtrl/ctrlMemory/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwData
    fwRuntime
    fwServices

    ctrlSelection
)

=== Bundles/LeafCtrl/ctrlSelection/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwComEd
    fwData
    fwRuntime
    fwServices
)

find_package (Boost REQUIRED)
fwForwardInclude(${Boost_INCLUDE_DIRS})

=== Bundles/LeafCtrl/monitor/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwGui
    fwRuntime
)

find_package (Boost REQUIRED)
fwForwardInclude(${Boost_INCLUDE_DIRS})


if(CMAKE_SYSTEM_NAME MATCHES "Windows")
    #TODO write FindDbgHelp ...
    target_link_libraries(${FWPROJECT_NAME} dbghelp)
endif()

=== Bundles/LeafIO/ioAtoms/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwAtomsBoostIO
    fwRuntime

    io
)

find_package (Boost REQUIRED)
fwForwardInclude(${Boost_INCLUDE_DIRS})

=== Bundles/LeafIO/ioData/CMakeLists.txt ===
fwLoadProperties()

fwUseForwardInclude(
    fwData
    fwDataTools
    fwGui
    fwRuntime
    fwServices

    io
)


find_package (Boost COMPONENTS system regex filesystem date_time chrono thread log log_setup REQUIRED)
fwForwardInclude(${Boost_INCLUDE_DIRS})
fwLink(${Boost_LIBRARIES})

=== debian/changelog ===
fw4spl (0.9.2-3) unstable; urgency=medium

  * Restrict package to amd64. Closes: #790288.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Thu, 16 Jul 2015 11:16:32 +0200

fw4spl (0.9.2-2) unstable; urgency=medium

  * Replace files from libqt4-qt3support by symlinks. Closes: #781298.
  * Fix FindHdf5.cmake to find hdf5 on i386 arch. Closes: #781294.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Fri, 27 Mar 2015 17:03:34 +0100

fw4spl (0.9.2-1) unstable; urgency=low

  * Initial release (Closes: #779632)

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Mon, 23 Mar 2015 11:19:00 +0100

=== debian/control ===
Source: fw4spl
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake (>= 2.8.11),
               libboost-all-dev (>= 1.54),
               zlib1g-dev,
               libexpat1-dev,
               libpng-dev,
               libtiff5-dev,
               libcppunit-dev,
               libhdf5-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libqt4-qt3support,
               libvtk5-dev,
               libgdcm2-dev,
               libinsighttoolkit3-dev,
               libann-dev,
               libvtkgdcm2-dev,
               libvtk5.8-qt4,
               libvxl1-dev,
               libcamp0.7-dev,
               xvfb,
               xauth,
               dbus-x11,
               rdfind,
               symlinks
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/fw4spl.git
Vcs-Git: git://anonscm.debian.org/debian-med/fw4spl.git
Homepage: https://code.google.com/p/fw4spl/

Package: fw4spl
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FrameWork for Software Production Line
 FW4SPL consists of a set of cross-platform C++ libraries.
 For now, FW4SPL focuses on the problem of medical images 
 processing and visualization, and propose an open-source 
 application called VRRender, which is able to load a 
 series of images stored in DICOM format (uncompressed 
 and JPEG) and 3D-modeled patients for medical review.

=== debian/rules ===
#!/usr/bin/make -f

#fix the lintian "hardening" message 
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE -DCMAKE_INSTALL_RPATH="/usr/lib/fw4spl" -Wno-dev

override_dh_auto_install:
	dh_auto_install --destdir=debian/fw4spl
	rdfind -outputname /dev/null -makesymlinks true debian/fw4spl/
	symlinks -r -s -c debian/fw4spl

override_dh_auto_test:
	echo "test disabled"

override_dh_shlibdeps:
	dh_shlibdeps -v -l/usr/lib:/usr/lib/fw4spl:/usr/lib/fw4spl/Bundles:/usr/lib/fw4spl/Bundles/gui_0-1/:/usr/lib/fw4spl/Bundles:/usr/lib/fw4spl/Bundles/io_0-1/:/usr/lib/fw4spl/Bundles:/usr/lib/fw4spl/Bundles/ctrlSelection_0-1/:/usr/lib/fw4spl/Bundles/ioITK_0-1/

=== debian/watch ===
version=3
https://github.com/corentindesfarges/fw4spl/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## fw4spl 14.0.0

=== CMakeLists.txt ===

cmake_minimum_required (VERSION 3.1)

project (fw4spl)

enable_testing()

include(CheckVariableExists)
include(CMakeParseArguments)
include(GNUInstallDirs)
include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/build/profile_config.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/build/plugin_config.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/install/generic_install.cmake)
include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/install/helper.cmake)

set(ENABLE_PCH ON CACHE BOOL "Use pre-compiled headers to speedup the compilation")
mark_as_advanced(ENABLE_PCH)

include(${CMAKE_CURRENT_SOURCE_DIR}/CMake/modules/PrecompiledHeader.cmake)

if(MSVC)
    if(NOT DEFINED CMAKE_PCH_COMPILER_TARGETS)
        # this will be executed in just before makefile generation
        variable_watch(CMAKE_BACKWARDS_COMPATIBILITY pch_msvc_hook)
    endif()
endif(MSVC)

set(BUILD_SHARED_LIBS ON)

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel")
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo;MinSizeRel")

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "Release" AND NOT CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo" AND NOT CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
    message(SEND_ERROR "Invalid value for CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE} (required Debug, Release, RelWithDebInfo or MinSizeRel)")
endif()
if(CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE} CACHE STRING "List of supported configurations." FORCE)
endif()

#Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER automoc)

if(MSVC AND ENABLE_PCH)
    # Store debug information in the .obj file instead of a PDB.
    string(REGEX REPLACE "/Z[iI]" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
    string(REGEX REPLACE "/Z[iI]" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
    # Force set debug compile flags.
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}" CACHE STRING "Debug flags" FORCE)
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}" CACHE STRING "RelWithDebInfo flags" FORCE)
endif()

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")  #racy backward compatibility

option(USE_SYSTEM_LIB "Use system libraries to compile fw4spl" OFF)

if(NOT USE_SYSTEM_LIB)
    set(EXTERNAL_LIBRARIES CACHE PATH "External libraries location")
endif()

set(FWCMAKE_RESOURCE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake/)

# Append our 'FindPackages.cmake' to CMAKE_MODULE_PATH and include BinPkgs config file
if(EXTERNAL_LIBRARIES)

    list(APPEND CMAKE_PREFIX_PATH ${EXTERNAL_LIBRARIES})
    list(APPEND CMAKE_MODULE_PATH ${EXTERNAL_LIBRARIES})
    list(APPEND CMAKE_FIND_ROOT_PATH ${EXTERNAL_LIBRARIES})
    include(${EXTERNAL_LIBRARIES}/lib/cmake/BinPkgsConfig.cmake)
    include(${EXTERNAL_LIBRARIES}/lib/cmake/find_sse.cmake)

    # This serves two purposes:
    # - The CUDA bundles/libs in FW4SPL projects will automatically find a working CUDA toolkit.
    # - Dependencies using CUDA such as OpenCV can find the toolkit they were compiled with, they might otherwise pick
    #   another one if you have several toolkits installed, which would cause an error.
    set(CUDA_TOOLKIT_ROOT_DIR ${BINPKGS_CUDA_TOOLKIT_ROOT_DIR} CACHE PATH
        "Version of the CUDA toolkit used for this build, if any. Read-only."
        FORCE)

elseif(USE_SYSTEM_LIB)

    list(APPEND CMAKE_PREFIX_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    list(APPEND CMAKE_MODULE_PATH ${FWCMAKE_RESOURCE_PATH}/modules)
    list(APPEND CMAKE_FIND_ROOT_PATH ${FWCMAKE_RESOURCE_PATH}/modules)

endif()


set(CREATE_SUBPROJECTS OFF CACHE BOOL "Create a project for each subproject")

set(BUILD_TESTS ON CACHE BOOL "Configures projects associated tests (<project>Test projects)")
set(TESTS_XML_OUTPUT OFF CACHE BOOL "Tests will generate an xml output, suitable for CI integration")
mark_as_advanced(TESTS_XML_OUTPUT)

set(ADDITIONAL_PROJECTS CACHE PATH
        "Paths to the additional projects"
)

set(SET_API_VERSION ON)

if(ADDITIONAL_PROJECTS)
    foreach(ADDITIONAL_PROJECT ${ADDITIONAL_PROJECTS})
        # parse additional CMakeLists
        if(EXISTS ${ADDITIONAL_PROJECT}/CMakeLists.txt)
            get_filename_component(DIRECTORY_PATH ${ADDITIONAL_PROJECT} ABSOLUTE )
            get_filename_component(DIR_NAME ${DIRECTORY_PATH} NAME )
            add_subdirectory(${ADDITIONAL_PROJECT} ${DIR_NAME})
        endif()
    endforeach()
endif()

if(ANDROID)
    set(BUNDLE_LIB_PREFIX "/data/data/com.fw4spl.${PROJECTS_TO_INSTALL}/Bundles")
    set(BUNDLE_RC_PREFIX "/data/data/com.fw4spl.${PROJECTS_TO_INSTALL}/Bundles")
else()
    if(WIN32)
        set(BUNDLE_LIB_PREFIX "${CMAKE_INSTALL_BINDIR}" CACHE PATH "Relative path where the bundles libraries are installed.")
    else()
        set(BUNDLE_LIB_PREFIX "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Relative path where the bundles libraries are installed.")
    endif()

    set(BUNDLE_RC_PREFIX "${CMAKE_INSTALL_DATADIR}" CACHE PATH "Relative path where the bundles resources are installed.")
endif()

mark_as_advanced(BUNDLE_LIB_PREFIX)
mark_as_advanced(BUNDLE_RC_PREFIX)

# Set warning level and function export visibility on Unix
if(UNIX)
    if(APPLE)
        # actually the flag -fvisibility=hidden makes application crash on OSX
        set(CMAKE_C_FLAG "${CMAKE_C_FLAGS} -Wall -Wextra -Wconversion -Wno-unused-parameter -Wno-ignored-qualifiers -fvisibility-ms-compat")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wconversion -Wno-unused-parameter -Wno-ignored-qualifiers -fvisibility-ms-compat")
        set(CMAKE_MACOSX_RPATH ON)
    else()
        set(CMAKE_C_FLAG "${CMAKE_C_FLAGS} -Wall -Wextra -Wconversion -Wno-unused-parameter -Wno-ignored-qualifiers -fvisibility=hidden")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wconversion -Wno-unused-parameter -Wno-ignored-qualifiers -fvisibility=hidden")
    endif()
    # Color for ninja and Clang on Linux and OSX
    if (CMAKE_GENERATOR STREQUAL "Ninja")
        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fcolor-diagnostics")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fcolor-diagnostics")
        #Color output for gcc > 4.9
        elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "4.8.99")
            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fdiagnostics-color")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-color")
        endif()
    endif()
endif()

# Building with all your cores on Visual Studio IDE
if(MSVC_IDE)
    set(CMAKE_C_FLAG "${CMAKE_C_FLAGS} /MP")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
endif()

if(BINPKGS_HAS_SSE)
    message(STATUS "SSE support detected in the dependencies, enabling SSE.")
    # Build with SSE support if possible
    fwFindSSE()

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${SSE_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SSE_FLAGS}")
    add_definitions("${SSE_DEFINITIONS}")
endif()

set(LIBRARY_OUTPUT_DIR lib)

if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    #http://stackoverflow.com/questions/6802903/c-ifdef-mac-os-x-question
    add_definitions(-D__MACOSX__) #racy backward compatibility
endif()


set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIBRARY_OUTPUT_DIR})
# Fixed path for multi-config builds (e.g. msvc)
foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
    string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
    set( CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/bin )
    set( CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${LIBRARY_OUTPUT_DIR} )
    set( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${LIBRARY_OUTPUT_DIR} )
endforeach()

set(SPYLOG_LEVEL "error" CACHE STRING "Log level")
set(SPYLOG_LEVEL_VALUES "fatal;error;warning;info;debug;trace" CACHE INTERNAL
    "List of possible values for log level")
set(SPYLOG_LEVEL_MAP_fatal 1)
set(SPYLOG_LEVEL_MAP_error 2)
set(SPYLOG_LEVEL_MAP_warning 3)
set(SPYLOG_LEVEL_MAP_info 4)
set(SPYLOG_LEVEL_MAP_debug 5)
set(SPYLOG_LEVEL_MAP_trace 6)
set_property(CACHE SPYLOG_LEVEL PROPERTY STRINGS ${SPYLOG_LEVEL_VALUES} )

# require C++11 standard by default
if(ANDROID)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11")
else()
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

macro(groupMaker FWPROJECT_NAME)
    file(GLOB_RECURSE PRJ_SOURCES "${${FWPROJECT_NAME}_DIR}/*")
    foreach(SRC ${PRJ_SOURCES})
        string(REGEX REPLACE ${${FWPROJECT_NAME}_DIR} "" REL_DIR "${SRC}")
        string(REGEX REPLACE "[\\\\/][^\\\\/]*$" "" REL_DIR "${REL_DIR}")
        string(REGEX REPLACE "^[\\\\/]" "" REL_DIR "${REL_DIR}")
        string(REPLACE "/" "\\" REL_DIR "${REL_DIR}")
        source_group("${REL_DIR}" FILES ${SRC})
    endforeach()

    file(GLOB_RECURSE PRJ_BUILD_SOURCES "${${FWPROJECT_NAME}_BUILD_DIR}/*.cpp" "${${FWPROJECT_NAME}_BUILD_DIR}/*.hpp")
    foreach(SRC ${PRJ_BUILD_SOURCES})
        source_group("genFiles" FILES ${SRC})
    endforeach()
endmacro()

macro(initProject PRJNAME )
    if(CREATE_SUBPROJECTS)
        project( ${PRJNAME} )
    endif()
    set(FWPROJECT_NAME ${PRJNAME})
    set(PRJ_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

    set(${FWPROJECT_NAME}_HEADERS)
    set(${FWPROJECT_NAME}_SOURCES)

    set(SUBDIRS ${ARGN})
    list(LENGTH SUBDIRS NB_SUBDIRS)
    if(NB_SUBDIRS EQUAL 0)
        list(APPEND SUBDIRS ${PRJ_SOURCE_DIR})
    endif()

    set(${FWPROJECT_NAME}_INCLUDE_DIR)

    foreach(SUBDIR ${SUBDIRS})
        list(APPEND ${FWPROJECT_NAME}_INCLUDE_DIR ${SUBDIR}/include)

        file(GLOB_RECURSE HEADERS ${SUBDIR}/include/*)
        file(GLOB_RECURSE SOURCES ${SUBDIR}/src/*)

        list(APPEND ${FWPROJECT_NAME}_HEADERS ${HEADERS})
        list(APPEND ${FWPROJECT_NAME}_SOURCES ${SOURCES})
    endforeach()

    set (${FWPROJECT_NAME}_INCLUDE_DIR ${${FWPROJECT_NAME}_INCLUDE_DIR} PARENT_SCOPE)
    set (${FWPROJECT_NAME}_DIR     ${CMAKE_CURRENT_SOURCE_DIR}  PARENT_SCOPE)
    set (${FWPROJECT_NAME}_BUILD_DIR ${CMAKE_BINARY_DIR}/${FWPROJECT_NAME})
    set (${FWPROJECT_NAME}_BUILD_DIR ${${FWPROJECT_NAME}_BUILD_DIR} PARENT_SCOPE)

    set (${FWPROJECT_NAME}_HEADERS ${${FWPROJECT_NAME}_HEADERS} PARENT_SCOPE)
    set (${FWPROJECT_NAME}_SOURCES ${${FWPROJECT_NAME}_SOURCES} PARENT_SCOPE)

    file(GLOB_RECURSE ${FWPROJECT_NAME}_RC_FILES "${PRJ_SOURCE_DIR}/rc/*" "${PRJ_SOURCE_DIR}/tu/rc/*")
    set(${FWPROJECT_NAME}_RC_FILES ${${FWPROJECT_NAME}_RC_FILES} PARENT_SCOPE)
    set_source_files_properties(${${FWPROJECT_NAME}_RC_FILES} PROPERTIES HEADER_FILE_ONLY TRUE)

    file(GLOB ${FWPROJECT_NAME}_CMAKE_FILES "${PRJ_SOURCE_DIR}/*.txt" "${PRJ_SOURCE_DIR}/*.cmake")
    set(${FWPROJECT_NAME}_CMAKE_FILES ${${FWPROJECT_NAME}_CMAKE_FILES} PARENT_SCOPE)
    set_source_files_properties(${${FWPROJECT_NAME}_CMAKE_FILES} PROPERTIES HEADER_FILE_ONLY TRUE)

    if (APPLE)
        set_source_files_properties(${${FWPROJECT_NAME}_RC_FILES} PROPERTIES XCODE_LAST_KNOWN_FILE_TYPE YES)
        set_source_files_properties(${${FWPROJECT_NAME}_CMAKE_FILES} PROPERTIES XCODE_LAST_KNOWN_FILE_TYPE YES)
    endif()

    groupMaker(${FWPROJECT_NAME})
endmacro()


macro(setVersion FWPROJECT_NAME PROJECT_VERSION)
    set(${FWPROJECT_NAME}_VERSION ${PROJECT_VERSION})
    set(${FWPROJECT_NAME}_VERSION ${PROJECT_VERSION} PARENT_SCOPE)
    set(${FWPROJECT_NAME}_FULLNAME ${FWPROJECT_NAME}-${PROJECT_VERSION})
    set(${FWPROJECT_NAME}_FULLNAME ${FWPROJECT_NAME}-${PROJECT_VERSION} PARENT_SCOPE)
endmacro()

macro(configureProject FWPROJECT_NAME PROJECT_VERSION)
    string(TOUPPER ${FWPROJECT_NAME} PROJECT_NAME_UPCASE)

=== fwlauncher/CMakeLists.txt ===
fwLoadProperties()

# TODO: We should manage to get rid of this definition
target_compile_definitions(${FWPROJECT_NAME} PRIVATE BUNDLE_RC_PREFIX="${BUNDLE_RC_PREFIX}")

find_package (Boost COMPONENTS program_options REQUIRED)
fwLink(${Boost_PROGRAM_OPTIONS_LIBRARY})

=== Bundles/style/CMakeLists.txt ===
fwLoadProperties()

find_package(Qt5 COMPONENTS Core REQUIRED)

file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/${BUNDLE_RC_PREFIX}/${${FWPROJECT_NAME}_FULLNAME}")

qt5_add_binary_resources(${FWPROJECT_NAME}_DARKSTYLE_RCC
    "rc/darkstyle.qrc"
    DESTINATION "${CMAKE_BINARY_DIR}/${BUNDLE_RC_PREFIX}/${${FWPROJECT_NAME}_FULLNAME}/darkstyle.rcc"
)

add_dependencies(${FWPROJECT_NAME} ${FWPROJECT_NAME}_DARKSTYLE_RCC)

=== Utilities/DicomAnonymizer/CMakeLists.txt ===
fwLoadProperties()

find_package(Boost COMPONENTS program_options REQUIRED)
fwLink(${Boost_LIBRARIES})

=== Utilities/DicomMetadataJsonGenerator/CMakeLists.txt ===
fwLoadProperties()

find_package(Boost COMPONENTS program_options REQUIRED)
fwLink(${Boost_LIBRARIES})

find_package(DCMTK REQUIRED)
fwInclude( ${DCMTK_config_INCLUDE_DIRS} )
fwLink( ${DCMTK_LIBRARIES} )

=== Utilities/VersionGenerator/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS program_options REQUIRED)

fwLink(
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
)

=== Bundles/core/activities/CMakeLists.txt ===
fwLoadProperties()

find_package(Qt5 COMPONENTS Core Gui Widgets REQUIRED)

fwForwardInclude(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
)

fwLink(
    ${Qt5Core_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
)

set_target_properties(${FWPROJECT_NAME} PROPERTIES AUTOMOC TRUE)

=== Bundles/core/gui/CMakeLists.txt ===
fwLoadProperties()


find_package (Boost COMPONENTS regex REQUIRED)

fwForwardInclude(${Boost_INCLUDE_DIRS})

fwLink(
    ${Boost_REGEX_LIBRARY}
)

=== Bundles/ctrl/ctrlCamp/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS regex REQUIRED)


fwForwardInclude(
    ${Boost_INCLUDE_DIRS}
)

fwForwardLink(
    ${Boost_REGEX_LIBRARY}
)

=== Bundles/ctrl/ctrlSelection/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS regex REQUIRED)
fwLink(${Boost_REGEX_LIBRARY})

=== Bundles/io/ioDicom/CMakeLists.txt ===
fwLoadProperties()

find_package(Qt5 COMPONENTS Core Gui Widgets REQUIRED)
fwLink(
    ${Qt5Core_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
)
fwInclude(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
)

set_target_properties(${FWPROJECT_NAME} PROPERTIES AUTOMOC TRUE)

=== Bundles/io/ioGdcm/CMakeLists.txt ===
fwLoadProperties()

find_package(Qt5 COMPONENTS Core Gui Widgets REQUIRED)

fwLink(
    ${Qt5Core_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
)
fwInclude(
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
)

set_target_properties(${FWPROJECT_NAME} PROPERTIES AUTOMOC TRUE)

=== debian/changelog ===
fw4spl (14.0.0-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:50:06 +0000

fw4spl (14.0.0-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version 
  * d/p/: remove obsolete patches
    Add patch to enable experimental GLM extension. Closes: #888932
  * d/rules: update build options

  [ Andreas Tille ]
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 28 Feb 2018 13:24:10 +0000

fw4spl (11.0.4-2) unstable; urgency=medium

  * Team upload.
  * d/control: Move to standards version 4.0.1
  * d/p/: Add patch fix_functional_include, Closes: #871111

 -- Gert Wollny <gewo@debian.org>  Mon, 21 Aug 2017 12:26:44 +0000

fw4spl (11.0.4-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload
  * Fix Homepage
    Closes: #812904

  [ Flavien Bridault ]
  * New upstream version
    Support libpng16. Closes: #809935.
    Support vtk6. Closes: #820632.
    Support insighttoolkit4. Closes: #821957.
    Support gcc5 build. Closes: #793240.
  * Removed Corentin Desfarges as Uploader
  * Added myself as Uploader
  * d/watch: Moved to official fw4spl fork
  * debhelper 10 (which enables parallel build as default). Closes: #797475.
  * d/control: Updated dependencies
  * cme fix dpkg-control 

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 23 Nov 2016 09:58:17 +0100

fw4spl (0.9.2-4) unstable; urgency=medium

  * Fix arm support.
  * Remove restriction to amd64.
  * Update dependencies in d/control.
  * Support new boost version. Closes: #797481.
  * Forbid parallel build. Closes: #797475.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Thu, 21 Dec 2015 14:11:13 +0200

=== debian/control ===
Source: fw4spl
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Flavien Bridault <fbridault@ircad.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake (>= 2.8.11),
               libboost-all-dev,
               zlib1g-dev,
               libexpat1-dev,
               libpng-dev,
               libtiff5-dev,
               libcppunit-dev,
               libhdf5-dev,
               libqt5opengl5-dev,
               libqt5x11extras5-dev,
               qttools5-dev,
               libvtk6-dev,
               libgdcm2-dev,
               libinsighttoolkit4-dev,
               libann-dev,
               libvtkgdcm2-dev,
               libvtk6.3-qt,
               libvtk6-qt-dev,
               libcamp0.7-dev,
               libglm-dev,
               xvfb,
               xauth,
               dbus-x11,
               rdfind,
               symlinks
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/fw4spl.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/fw4spl.git
Homepage: https://fw4spl-org.github.io/

Package: fw4spl
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FrameWork for Software Production Line
 FW4SPL consists of a set of cross-platform C++ libraries.
 For now, FW4SPL focuses on the problem of medical images 
 processing and visualization, and propose an open-source 
 application called VRRender, which is able to load a 
 series of images stored in DICOM format (uncompressed 
 and JPEG) and 3D-modeled patients for medical review.
